## kadu 0.11.2

=== CMakeLists.txt ===
project (kadu)

# minimal required versions
set (QT_MIN_VERSION "4.7.0")
set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

cmake_minimum_required (VERSION 2.8.0 FATAL_ERROR)

if (WIN32 AND NOT BUILD_DESCRIPTION)
	set (BUILD_DESCRIPTION "Compiled from sources" CACHE STRING "Build description" FORCE)
endif (WIN32 AND NOT BUILD_DESCRIPTION)

if (COMMAND cmake_policy)
	cmake_policy (SET CMP0003 NEW)

	if (${CMAKE_VERSION} VERSION_GREATER 2.8.0)
		cmake_policy (SET CMP0015 OLD)
	endif (${CMAKE_VERSION} VERSION_GREATER 2.8.0)
endif (COMMAND cmake_policy)

include (FindPkgConfig)
include (CheckIncludeFiles)
include (CheckFunctionExists)

if (NOT KADU_VERSION)
	find_program (GIT_EXECUTABLE git DOC "git command line client")
	if (GIT_EXECUTABLE)
		execute_process (COMMAND ${GIT_EXECUTABLE} describe --tags HEAD
			WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
			OUTPUT_VARIABLE KADU_VERSION
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif (GIT_EXECUTABLE)

	if (NOT KADU_VERSION)
		file (READ ${CMAKE_CURRENT_SOURCE_DIR}/VERSION KADU_VERSION)
		string (REPLACE "\n" "" KADU_VERSION ${KADU_VERSION})
	endif (NOT KADU_VERSION)
endif (NOT KADU_VERSION)

if (WIN32)
	# Add more version info to files
	string (REGEX REPLACE "(.+)\\.(.+)\\.(.+)[.-].*" "\\1, \\2, \\3, 0" NUMERIC_VERSION ${KADU_VERSION})
	set (PACKAGE_VERSION ${KADU_VERSION})

	# package
	set (CPACK_GENERATOR "ZIP")
	set (CPACK_PACKAGE_VERSION ${PACKAGE_VERSION})
	include (CPack)
endif (WIN32)

if (NOT WIN32)
	# TODO: Add libexecinfo support
	check_include_files ("execinfo.h" HAVE_EXECINFO)
	if (HAVE_EXECINFO)
		check_function_exists ("backtrace" HAVE_EXECINFO)
	endif (HAVE_EXECINFO)

	if (SIG_HANDLING_ENABLED)
		set (SIG_HANDLING_ENABLED 1)
	endif (SIG_HANDLING_ENABLED)
endif (NOT WIN32)

set (KADU_INSTALLS_SDK TRUE)
include (FindKadu)
include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/kadu-core ${QT_INCLUDES})

if (INSTALL_SDK)
	install (FILES cmake/FindKadu.cmake DESTINATION ${KADU_CMAKE_MODULES_DIR})
endif (INSTALL_SDK)

# build
configure_file (${CMAKE_SOURCE_DIR}/kadu-config.h.cmake ${CMAKE_BINARY_DIR}/kadu-config.h)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)

add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# kadu-core sets WITH_LIBINDICATE_QT option which is used by Plugins.cmake
add_subdirectory (kadu-core)
include (Plugins.cmake)
add_subdirectory (plugins)
add_subdirectory (varia)
add_subdirectory (translations)
add_subdirectory (kthxbye)

message (STATUS "Kadu (version: ${KADU_VERSION}) will be built:")
message (STATUS " * install prefix: ${CMAKE_INSTALL_PREFIX}")
message (STATUS " * build type: ${CMAKE_BUILD_TYPE}")

# install data files
install (FILES AUTHORS HISTORY README THANKS ChangeLog ChangeLog.OLD-PL COPYING DESTINATION ${KADU_DATA_DIR})

=== globalhotkeys/CMakeLists.txt ===
project( globalhotkeys )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	globalhotkeys.cpp
	api.cpp
	buddiesmenu.cpp
	conf.cpp
	functions.cpp
	globalmenu.cpp
	globalwidgetmanager.cpp
	hotkey.cpp
	hotkeyedit.cpp
	serializableqstringlist.cpp
	statusesmenu.cpp
	wideiconsmenu.cpp
)

set( MOC_SOURCES
	globalhotkeys.h
	buddiesmenu.h
	conf.h
	functions.h
	globalmenu.h
	globalwidgetmanager.h
	statusesmenu.h
)

set( TRANSLATION_SOURCES
	translations/globalhotkeys_en.ts
	translations/globalhotkeys_cs.ts
	translations/globalhotkeys_it.ts
	translations/globalhotkeys_pl.ts
)

set( CONFIGURATION_FILES
	configuration/globalhotkeys.ui
)

kadu_plugin( globalhotkeys
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

=== importhistory/CMakeLists.txt ===
project (import_history)

# minimal required versions
cmake_minimum_required (VERSION 2.8)
set (QT_MIN_VERSION "4.7.0")
set (CMAKE_MIN_VERSION "2.8.0")

set (KADU_FIND_REQUIRED true)
include (FindKadu)

include (FindPkgConfig)

set (SOURCES
  import_history.cpp
  gui/gui.cpp
  importers/importer.cpp
  importers/gg7/crc32.cpp
  importers/gg7/ggimporter.cpp
  importers/gg8/gg8importer.cpp
  misc/memfile.cpp
)

set (MOC_SOURCES
  import_history.h
  gui/gui.h
  importers/importer.h
  importers/gg7/ggimporter.h
  importers/gg8/gg8importer.h
)

set (TRANSLATION_SOURCES
  translations/import_history_pl.ts
  translations/import_history_de.ts
  translations/import_history_it.ts
  translations/import_history_fr.ts
)

set (CONFIGURATION_FILES
)

if (WIN32)
  # we need to bundle sqlite on Windows
  list (APPEND SOURCES
    sqlite3.c
  )

  set_source_files_properties (sqlite3.c PROPERTIES
    COMPILE_FLAGS "-fno-strict-aliasing -Wno-error"
  )
endif (WIN32)

if (WIN32)
	if (NOT MINGW_LIBGADU_DIR)
		message (SEND_ERROR " Pass path to libgadu -DMINGW_LIBGADU_DIR=path")
		set (MINGW_LIBGADU_DIR "")
	else (NOT MINGW_LIBGADU_DIR)
		set (LIBGADU_FOUND true)
		set (LIBGADU_INCLUDE_DIRS ${MINGW_LIBGADU_DIR})
		set (LIBGADU_LIBRARY_DIRS ${MINGW_LIBGADU_DIR})
		set (LIBGADU_LIBRARIES gadu ws2_32)
	endif (NOT MINGW_LIBGADU_DIR)
else (WIN32)
	pkg_search_module (LIBGADU REQUIRED libgadu)
endif (WIN32)

include_directories (${LIBGADU_INCLUDE_DIRS})
link_directories (${LIBGADU_LIBRARY_DIRS})

qt4_wrap_ui(import_history_UIS gui/import_history.ui)
include_directories (${CMAKE_CURRENT_BINARY_DIR})

kadu_plugin(import_history
  PLUGIN_SOURCES ${SOURCES} ${import_history_UIS}
  PLUGIN_MOC_SOURCES ${MOC_SOURCES}
  PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
  PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
  PLUGIN_LIBRARIES ${LIBGADU_LIBRARIES}
  PLUGIN_DEPENDENCIES history gadu_protocol
)

=== kadu-core/CMakeLists.txt ===
if (NOT MSVC)
	option (FAST_LINKING "Enable for faster linking, optimized for low RAM (works best with GCC and GNU ld)" ON)
else (NOT MSVC)
	option (FAST_LINKING "Enable for faster linking, optimized for low RAM (works best with GCC and GNU ld)" OFF)
endif (NOT MSVC)

if (FAST_LINKING)
	message (STATUS "Fast linking enabled")
endif (FAST_LINKING)

if (UNIX)
	option (SIG_HANDLING_ENABLED "Define if you want system signals handling" ON)

	if (NOT APPLE)
		option (USE_X11_XFIXES "Use X11 XFixes extension (Desktop Linux)" ON)

		pkg_search_module (INDICATEQT indicate-qt)
		if (INDICATEQT_FOUND)
			message (STATUS "libindicate-qt devel found. Enabling Ayatana support")
			option (WITH_LIBINDICATE_QT "Compile with Messaging Menu (Ayatana) support trough libindicate-qt" ON)
		else (INDICATEQT_FOUND)
			message (STATUS "libindicate-qt devel NOT FOUND. Disabling Ayatana support")
			option (WITH_LIBINDICATE_QT "Compile with Messaging Menu (Ayatana) support trough libindicate-qt" OFF)
		endif (INDICATEQT_FOUND)
	endif (NOT APPLE)
endif (UNIX)

if (NOT NETWORK_IMPLEMENTATION)
	include (FindQNtrack)
	if (QNTRACK_FOUND)
		set (NETWORK_IMPLEMENTATION "ntrack" CACHE STRING "Select network-aware implementation (Qt/ntrack/dummy)" FORCE)
		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: ntrack")
	else (QNTRACK_FOUND)
		set (NETWORK_IMPLEMENTATION "Qt" CACHE STRING "Select network-aware implementation (Qt/ntrack/dummy)" FORCE)
		message (STATUS "No NETWORK_IMPLEMENTATION defined. Autodetected implementation: Qt")
	endif (QNTRACK_FOUND)
elseif (${NETWORK_IMPLEMENTATION} STREQUAL "ntrack")
	set (QNtrack_FIND_REQUIRED true)
	include (FindQNtrack)
endif (NOT NETWORK_IMPLEMENTATION)

set (kadu_SRCS
	activate.cpp
	debug.cpp
	html_document.cpp
	kadu-application.cpp
	languages-manager.cpp
	themes.cpp
	updates.cpp
)

if (UNIX AND NOT APPLE)
	list (APPEND kadu_SRCS
		os/x11tools.cpp
	)
endif (UNIX AND NOT APPLE)
if (NOT WIN32)
	list (APPEND kadu_SRCS
		os/qtsingleapplication/qtlocalpeer.cpp
		os/qtsingleapplication/qtlockedfile.cpp
	)
endif (NOT WIN32)

set (kadu_MOC_SRCS
	kadu-application.h
	themes.h
	updates.h
)

set (kadu_SUBDIRS
	accounts
	avatars
	buddies
	chat
	configuration
	contacts
	core
	emoticons
	file-transfer
	gui
	icons
	identities
	message
	misc
	model
	multilogon
	network
	notify
	os
	parser
	plugins
	protocols
	qt
	status
	storage
	talkable
	themes
	url-handlers
)

qt4_wrap_cpp (MOC_FILES ${kadu_MOC_SRCS})

set (ADDITIONAL_LIBRARIES "")

if (WIN32)
	if (NOT WIN_QCA_DIR)
		message (SEND_ERROR "Pass path to libqca2 -DWIN_QCA_DIR=path")
	else (NOT WIN_QCA_DIR)
		set (QCA2_INCLUDE_DIRS ${WIN_QCA_DIR}/include/QtCrypto)

		if (MSVC)
			set (QCA2_LIBRARY_DIRS ${WIN_QCA_DIR}/lib)
		else (MSVC)
			set (QCA2_LIBRARY_DIRS ${WIN_QCA_DIR}/bin)
		endif (MSVC)

		if (CMAKE_BUILD_TYPE STREQUAL "Debug")
			set (QCA2_LIBRARIES qcad2)
		else (CMAKE_BUILD_TYPE STREQUAL "Debug")
			set (QCA2_LIBRARIES qca2)
		endif (CMAKE_BUILD_TYPE STREQUAL "Debug")
	endif (NOT WIN_QCA_DIR)
else (WIN32)
	pkg_search_module (QCA2 REQUIRED qca2)
endif (WIN32)

link_directories (${QCA2_LIBRARY_DIRS})
add_definitions (${QCA2_CFLAGS_OTHER})
include_directories (${QCA2_INCLUDE_DIRS})

if (UNIX AND NOT APPLE)
	if (WITH_LIBINDICATE_QT)
		# We need to link core to libindicate-qt so that indicator_docking
		# doesn't crash at unloading. And it crashes mainly because dbus-glib
		# doesn't support being dlclose()'d, so there is no better workaround.
		link_directories (${INDICATEQT_LIBRARY_DIRS})
		add_definitions (${INDICATEQT_CFLAGS_OTHER})
		include_directories (${INDICATEQT_INCLUDE_DIRS})
		list (APPEND ADDITIONAL_LIBRARIES ${INDICATEQT_LIBRARIES})
	endif (WITH_LIBINDICATE_QT)

	if (${NETWORK_IMPLEMENTATION} STREQUAL "ntrack")
		list (APPEND ADDITIONAL_LIBRARIES ${QNTRACK_LIBRARIES})
	endif (${NETWORK_IMPLEMENTATION} STREQUAL "ntrack")

	include (FindX11)
	if (X11_FOUND)
		message (STATUS "Found X11 libraries: ${X11_X11_LIB}")
	else (X11_Xfixes_FOUND)
		message (FATAL_ERROR "Could not find X11 libraries")
	endif (X11_FOUND)

	include_directories (${X11_INCLUDE_DIR})

	if (USE_X11_XFIXES)
		if (X11_Xfixes_FOUND)
			message (STATUS "Found X11 Xfixes extension: ${X11_Xfixes_LIB}")
		else (X11_Xfixes_FOUND)
			message (FATAL_ERROR "Could not find X11 Xfixes extension")
		endif (X11_Xfixes_FOUND)
	endif (USE_X11_XFIXES)

	if (NOT DESKTOP_ENTRY)
		set (DESKTOP_ENTRY ${CMAKE_CURRENT_BINARY_DIR}/kadu.desktop)
	endif (NOT DESKTOP_ENTRY)
	add_custom_command (OUTPUT ${DESKTOP_ENTRY}
		COMMAND touch ${DESKTOP_ENTRY}
		COMMAND sh ${CMAKE_SOURCE_DIR}/varia/scripts/create_kadu_desktop.sh ${CMAKE_INSTALL_PREFIX} > ${DESKTOP_ENTRY}
		DEPENDS ${CMAKE_SOURCE_DIR}/varia/scripts/create_kadu_desktop.sh
		COMMENT "Generating desktop entry file"
	)
	add_custom_target (DESKTOP_ENTRY_FILE ALL
		DEPENDS ${DESKTOP_ENTRY}
	)
endif (UNIX AND NOT APPLE)

macro (kadu_subdirectory SUBDIR SRCS MOC_SRCS ADDITIONAL_INCLUDES)
	if (FAST_LINKING)
		set (${SUBDIR}_MOC_FILES "")
		if (NOT "${MOC_SRCS}" STREQUAL "")
			qt4_wrap_cpp (${SUBDIR}_MOC_FILES ${MOC_SRCS})
		endif (NOT "${MOC_SRCS}" STREQUAL "")

		add_library (${SUBDIR}
			STATIC
			${SRCS}
			${${SUBDIR}_MOC_FILES}
		)
		set_target_properties (${SUBDIR} PROPERTIES COMPILE_DEFINITIONS KADULIB)
	else (FAST_LINKING)
		set (tmp "")
		foreach (SRC ${SRCS})
			set (tmp "${tmp};${SUBDIR}/${SRC}")
		endforeach (SRC)

		set (tmp_moc "")
		foreach (MOC_SRC ${MOC_SRCS})
			set (tmp_moc "${tmp_moc};${SUBDIR}/${MOC_SRC}")
		endforeach (MOC_SRC)

		set (${SUBDIR}_SRCS "${tmp}" PARENT_SCOPE)
		set (${SUBDIR}_MOC_SRCS "${tmp_moc}" PARENT_SCOPE)
		set (${SUBDIR}_INCLUDES "${ADDITIONAL_INCLUDES}" PARENT_SCOPE)
	endif (FAST_LINKING)
endmacro (kadu_subdirectory)

macro (kadu_source_subdirectories CURRENT_TARGET)
	foreach (ARG ${ARGN})
		add_subdirectory (${ARG})

		if (FAST_LINKING)
			link_directories (${ARG})
			add_dependencies (${CURRENT_TARGET}
				${ARG}
			)
		else (FAST_LINKING)
			list (APPEND kadu_SRCS "${${ARG}_SRCS}")
			qt4_wrap_cpp (MOC_FILES "${${ARG}_MOC_SRCS}")
			include_directories (${${ARG}_INCLUDES})
		endif (FAST_LINKING)
	endforeach (ARG)

	if (FAST_LINKING)
		if (APPLE)
			target_link_libraries (${CURRENT_TARGET} -Wl,-all_load ${ARGN})
		else (APPLE)
			target_link_libraries (${CURRENT_TARGET} -Wl,--start-group -Wl,--whole-archive ${ARGN} -Wl,--no-whole-archive -Wl,--end-group)
		endif (APPLE)
	endif (FAST_LINKING)
endmacro (kadu_source_subdirectories)

if (WIN32)
	list (APPEND kadu_SRCS
		os/qtsingleapplication/qtlocalpeer.cpp
		os/qtsingleapplication/qtlockedfile.cpp
		os/qtsingleapplication/qtlockedfile_win.cpp
	)

	if (NOT FAST_LINKING)
		kadu_source_subdirectories (kadu_core ${kadu_SUBDIRS})
	endif (NOT FAST_LINKING)
	add_library (kadu_core SHARED ${kadu_SRCS} ${MOC_FILES} kadu_core.rc)
	if (FAST_LINKING)
		kadu_source_subdirectories (kadu_core ${kadu_SUBDIRS})
	endif (FAST_LINKING)

	set_target_properties (kadu_core PROPERTIES
		COMPILE_DEFINITIONS KADULIB
		LINK_INTERFACE_LIBRARIES ""
	)
	target_link_libraries (kadu_core ${QT_LIBRARIES} ${QCA2_LIBRARIES} ${ADDITIONAL_LIBRARIES})

	if (MINGW)
		exec_program (windres ${CMAKE_CURRENT_SOURCE_DIR}
			ARGS "kadu_mingw.rc kadu_rc.o"
			OUTPUT_VARIABLE NULL_VAR
		)
		add_executable (kadu WIN32 main.cpp main_win32.cpp kadu_rc.o)
		add_executable (kadu_c main.cpp main_win32.cpp)
	else (MINGW)
		add_executable (kadu WIN32 main.cpp main_win32.cpp kadu.rc)
		add_executable (kadu_c main.cpp main_win32.cpp kadu.rc)
	endif (MINGW)

	set_target_properties (kadu_c PROPERTIES COMPILE_DEFINITIONS KADU_CONSOLE)

	target_link_libraries (kadu kadu_core ${QT_QTMAIN_LIBRARY} ${QT_LIBRARIES} ws2_32)
	target_link_libraries (kadu_c kadu_core ${QT_LIBRARIES} ws2_32)

	if (INSTALL_SDK)
		install (TARGETS kadu_core
			ARCHIVE DESTINATION ${KADU_SDK_DIR}/lib
			LIBRARY DESTINATION ${KADU_SDK_DIR}/lib
		)
	endif (INSTALL_SDK)

	install (TARGETS kadu_core RUNTIME DESTINATION ${KADU_BIN_DIR})
	install (TARGETS kadu_c DESTINATION ${KADU_BIN_DIR})
else (WIN32)
	if (NOT FAST_LINKING)
		kadu_source_subdirectories (kadu ${kadu_SUBDIRS})
	endif (NOT FAST_LINKING)
	add_executable (kadu main.cpp main_unix.cpp os/qtsingleapplication/qtlockedfile_unix.cpp ${kadu_SRCS} ${MOC_FILES})
	if (FAST_LINKING)
		kadu_source_subdirectories (kadu ${kadu_SUBDIRS})
	endif (FAST_LINKING)

	set_target_properties (kadu PROPERTIES
		ENABLE_EXPORTS ON
		COMPILE_DEFINITIONS KADULIB
		LINK_INTERFACE_LIBRARIES ""
	)

	target_link_libraries (kadu ${QT_LIBRARIES} ${QCA2_LIBRARIES} ${CMAKE_DL_LIBS} ${ADDITIONAL_LIBRARIES})

	if (UNIX AND NOT APPLE)
		target_link_libraries (kadu ${X11_X11_LIB})

		if (USE_X11_XFIXES)
			target_link_libraries (kadu ${X11_Xfixes_LIB})
		endif (USE_X11_XFIXES)
	endif (UNIX AND NOT APPLE)
endif (WIN32)

install (TARGETS kadu DESTINATION ${KADU_BIN_DIR})

# install desktop file
if (UNIX AND NOT APPLE)
	install (FILES ${DESKTOP_ENTRY} DESTINATION ${KADU_DESKTOP_FILE_DIR} RENAME ${KADU_DESKTOP_FILE_NAME})

	# install icons
	install (FILES hi16-app-kadu.png DESTINATION "share/icons/hicolor/16x16/apps" RENAME kadu.png)
	install (FILES hi22-app-kadu.png DESTINATION "share/icons/hicolor/22x22/apps" RENAME kadu.png)
	install (FILES hi24-app-kadu.png DESTINATION "share/icons/hicolor/24x24/apps" RENAME kadu.png)
	install (FILES hi32-app-kadu.png DESTINATION "share/icons/hicolor/32x32/apps" RENAME kadu.png)
	install (FILES hi48-app-kadu.png DESTINATION "share/icons/hicolor/48x48/apps" RENAME kadu.png)
	install (FILES hi64-app-kadu.png DESTINATION "share/icons/hicolor/64x64/apps" RENAME kadu.png)
	install (FILES hi128-app-kadu.png DESTINATION "share/icons/hicolor/128x128/apps" RENAME kadu.png)
	# As of icon-theme-0.5 maximum supported pixmap size is 192, for anything larger one should use SVG.
	#install (FILES hi256-app-kadu.png DESTINATION "share/icons/hicolor/256x256/apps" RENAME kadu.png)
endif (UNIX AND NOT APPLE)

install (FILES "chat/style-engines/chat-scripts.js" DESTINATION ${KADU_DATA_DIR}/scripts)

if (APPLE)
	target_link_libraries (kadu "-framework carbon")
endif (APPLE)

# install api headers
kadu_api_directories (kadu-core
	accounts/filter
	accounts/model
	accounts
	avatars
	buddies/filter
	buddies/model
	buddies
	chat/model
	chat/style-engines/style-engine-adium
	chat/style-engines/style-engine-kadu
	chat/style-engines
	chat/type
	chat
	configuration
	contacts/filter
	contacts/model
	contacts
	core
	emoticons
	file-transfer
	gui/actions/chat
	gui/actions
	gui/widgets/configuration
	gui/widgets
	gui/windows/open-chat-with
	gui/windows
	gui
	icons
	identities/model
	identities
	message
	misc
	model
	multilogon/model
	multilogon
	network/proxy/model
	network/proxy
	network
	notify
	os/generic
	os/qtsingleapplication
	os
	parser
	plugins
	protocols/filter
	protocols/model
	protocols/services
	protocols
	qt
	status
	storage
	talkable/filter
	talkable/model
	talkable
	themes
	url-handlers
	.
)

=== nextinfo/CMakeLists.txt ===
project( nextinfo )

cmake_minimum_required( VERSION 2.8 )
set( QT_MIN_VERSION "4.7.0" )
set( CMAKE_MIN_VERSION "2.8.0" )

set( KADU_FIND_REQUIRED true )
include( FindKadu )

include_directories( ${KADU_INCLUDE_DIR} )
include_directories( ${KADU_INCLUDE_DIR}/kadu-core )

set( SOURCES
	nextinfo.cpp
	buddynextinfodata.cpp
	extendedinformationwidgets.cpp
	photowidget.cpp
)

set( MOC_SOURCES
	nextinfo.h
	buddynextinfodata.h
	extendedinformationwidgets.h
	photowidget.h
)

set( TRANSLATION_SOURCES
	translations/nextinfo_en.ts
	translations/nextinfo_cs.ts
	translations/nextinfo_pl.ts
)

set( CONFIGURATION_FILES
	configuration/nextinfo.ui
)

set( QT_USE_QTSCRIPT 1 )
include( ${QT_USE_FILE} )

kadu_plugin( nextinfo
	PLUGIN_SOURCES ${SOURCES}
	PLUGIN_MOC_SOURCES ${MOC_SOURCES}
	PLUGIN_TRANSLATION_SOURCES ${TRANSLATION_SOURCES}
	PLUGIN_CONFIGURATION_FILES ${CONFIGURATION_FILES}
)

target_link_libraries( nextinfo ${QT_QTSCRIPT_LIBRARY} )

=== plugins/CMakeLists.txt ===
option (BUILD_PLUGINS "Switch to OFF if you do not want to build plugins" ON)

if (BUILD_PLUGINS)
	if (NOT WIN32)
		find_program (AWK gawk awk)
		if (AWK)
			set (_COMPILE_PLUGINS "")
			foreach (ARG ${COMPILE_PLUGINS})
				set (_COMPILE_PLUGINS "${_COMPILE_PLUGINS} ${ARG}")
			endforeach (ARG)

			exec_program (${CMAKE_CURRENT_SOURCE_DIR}/check-deps.sh ${CMAKE_CURRENT_SOURCE_DIR}
				ARGS ${AWK} ${_COMPILE_PLUGINS}
				OUTPUT_VARIABLE DEPS_MESSAGE
				RETURN_VALUE DEPS_STATUS
			)

			if (DEPS_STATUS EQUAL 1)
				message (FATAL_ERROR ${DEPS_MESSAGE})
			endif (DEPS_STATUS EQUAL 1)
		endif (AWK)
	endif (NOT WIN32)

	foreach (PLUGIN ${COMPILE_PLUGINS})
		message (STATUS "Plugin: " ${PLUGIN})
		if (WIN32)
			set (${PLUGIN} SHARED)
		else (WIN32)
			set (${PLUGIN} PLUGIN)
		endif (WIN32)
		add_subdirectory (${PLUGIN})
	endforeach (PLUGIN)
endif (BUILD_PLUGINS)

if (WIN32 AND INSTALL_SDK)
	install (FILES plugin.rc DESTINATION ${KADU_PLUGINS_SDK_DIR})
	install (FILES plugver.bat DESTINATION ${KADU_PLUGINS_SDK_DIR})
endif (WIN32 AND INSTALL_SDK)

=== translations/CMakeLists.txt ===
set (TRANSLATION_SOURCES
	kadu_en.ts
	kadu_cs.ts
	kadu_de.ts
	kadu_es_ES.ts
	kadu_fr.ts
	kadu_it.ts
	kadu_pl.ts
	kadu_ru.ts
	kadu_sk.ts
)

set (LANGAUGE_FILES
	cs.language
	de.language
	en.language
	pl.language
	ru.language
)

qt4_add_translation (TRANSLATION_FILES ${TRANSLATION_SOURCES})

add_custom_target (translations DEPENDS ${TRANSLATION_FILES})
add_dependencies (kadu translations)

install (FILES ${TRANSLATION_FILES} ${LANGAUGE_FILES}
	DESTINATION ${KADU_DATA_DIR}/translations
)

if (INSTALL_SDK)
	install (PROGRAMS plugintsupdate.sh DESTINATION ${KADU_PLUGINS_SDK_DIR})
	install (FILES configuration-ui.xsl DESTINATION ${KADU_PLUGINS_SDK_DIR})
endif (INSTALL_SDK)

=== kadu-core/buddies/CMakeLists.txt ===
set (buddies_SRCS
	buddy.cpp
	buddy-additional-data-delete-handler.cpp
	buddy-additional-data-delete-handler-manager.cpp
	buddy-kadu-data.cpp
	buddy-list.cpp
	buddy-list-mime-data-helper.cpp
	buddy-manager.cpp
	buddy-preferred-manager.cpp
	buddy-search-criteria.cpp
	buddy-set.cpp
	buddy-shared.cpp
	group.cpp
	group-manager.cpp
	group-shared.cpp

	model/buddy-data-extractor.cpp
	model/buddy-list-model.cpp
	model/buddies-model.cpp
	model/buddies-model-base.cpp
	# will be used when Qt 4.8 .is required
	# model/checkable-buddies-proxy-model.cpp
	model/groups-model.cpp
)

set (buddies_MOC_SRCS
	buddy-additional-data-delete-handler-manager.h
	buddy-kadu-data.h
	buddy-shared.h
	buddy-manager.h
	group-manager.h
	buddy-preferred-manager.h
	group-shared.h

	model/buddy-list-model.h
	model/buddies-model.h
	model/buddies-model-base.h
	# will be used when Qt 4.8 .is required
	# model/checkable-buddies-proxy-model.h
	model/groups-model.h
)

kadu_subdirectory (buddies "${buddies_SRCS}" "${buddies_MOC_SRCS}" "")

=== kadu-core/chat/CMakeLists.txt ===
set (chat_SRCS
	aggregate-chat-manager.cpp
	chat.cpp
	chat-details-aggregate.cpp
	chat-details-conference.cpp
	chat-details-simple.cpp
	chat-geometry-data.cpp
	chat-list-mime-data-helper.cpp
	chat-manager.cpp
	chat-shared.cpp
	chat-styles-manager.cpp
	html-messages-renderer.cpp
	recent-chat-manager.cpp

	model/chat-data-extractor.cpp
	model/chats-model.cpp

	style-engines/chat-engine-adium/adium-style.cpp
	style-engines/chat-engine-adium/adium-time-formatter.cpp
	style-engines/chat-engine-adium/chat-engine-adium.cpp
	style-engines/chat-engine-kadu/chat-engine-kadu.cpp
	style-engines/chat-engine-kadu/kadu-chat-syntax.cpp

	type/chat-type.cpp
	type/chat-type-aggregate.cpp
	type/chat-type-aware-object.cpp
	type/chat-type-conference.cpp
	type/chat-type-manager.cpp
	type/chat-type-simple.cpp
)

set (chat_MOC_SRCS
	chat-details.h
	chat-details-aggregate.h
	chat-details-conference.h
	chat-details-simple.h
	chat-geometry-data.h

	aggregate-chat-manager.h
	chat-manager.h
	chat-shared.h
	chat-styles-manager.h
	html-messages-renderer.h
	recent-chat-manager.h

	model/chats-model.h

	style-engines/chat-engine-adium/chat-engine-adium.h
	style-engines/chat-engine-kadu/chat-engine-kadu.h

	type/chat-type.h
	type/chat-type-aggregate.h
	type/chat-type-conference.h
	type/chat-type-manager.h
	type/chat-type-simple.h
)

kadu_subdirectory (chat "${chat_SRCS}" "${chat_MOC_SRCS}" "")

=== kadu-core/contacts/CMakeLists.txt ===
set (contacts_SRCS
	contact.cpp
	contact-details.cpp
	contact-manager.cpp
	contact-parser-tags.cpp
	contact-set.cpp
	contact-set-configuration-helper.cpp
	contact-shared.cpp

	model/buddy-contact-model.cpp
	model/contact-data-extractor.cpp
	model/contact-list-model.cpp
)

set (contacts_MOC_SRCS
	contact-manager.h
	contact-shared.h

	model/buddy-contact-model.h
	model/contact-list-model.h
)

kadu_subdirectory (contacts "${contacts_SRCS}" "${contacts_MOC_SRCS}" "")

=== kadu-core/gui/CMakeLists.txt ===
set (gui_SRCS
	hot-key.cpp
	status-icon.cpp

	actions/chat/add-conference-action.cpp
	actions/chat/leave-chat-action.cpp

	actions/action.cpp
	actions/actions.cpp
	actions/action-description.cpp
	actions/base-action-context.cpp
	actions/change-status-action.cpp
	actions/default-proxy-action.cpp
	actions/delete-talkable-action.cpp
	actions/edit-talkable-action.cpp

	widgets/account-buddy-list-widget.cpp
	widgets/account-avatar-widget.cpp
	widgets/accounts-combo-box.cpp
	widgets/actions-combo-box.cpp
	widgets/avatar-painter.cpp
	widgets/buddy-avatar-widget.cpp
	widgets/buddy-contacts-table-delegate.cpp
	widgets/buddy-contacts-table-item.cpp
	widgets/buddy-contacts-table-model.cpp
	widgets/buddy-contacts-table-model-proxy.cpp
	widgets/buddy-contacts-table.cpp
	widgets/buddy-general-configuration-widget.cpp
	widgets/buddy-groups-configuration-widget.cpp
	widgets/buddy-personal-info-configuration-widget.cpp
	widgets/buddy-options-configuration-widget.cpp
	widgets/buddy-info-panel.cpp
	widgets/chat-edit-box.cpp
	widgets/chat-edit-box-size-manager.cpp
	widgets/chat-messages-view.cpp
	widgets/chat-view-network-access-manager.cpp
	widgets/chat-widget.cpp
	widgets/chat-widget-actions.cpp
	widgets/chat-widget-manager.cpp
	widgets/choose-identity-widget.cpp
	widgets/color-button.cpp
	widgets/color-selector.cpp
	widgets/custom-input.cpp
	widgets/custom-input-menu-item.cpp
	widgets/custom-input-menu-manager.cpp
	widgets/delayed-line-edit.cpp
	widgets/file-transfer-widget.cpp
	widgets/filter-widget.cpp
	widgets/filtered-tree-view.cpp
	widgets/group-list.cpp
	widgets/group-tab-bar.cpp
	widgets/groups-combo-box.cpp
	widgets/identities-combo-box.cpp
	widgets/kadu-tree-view.cpp
	widgets/kadu-tree-view-delegate.cpp
	widgets/kadu-web-view.cpp
	widgets/line-edit-clear-button.cpp
	widgets/line-edit-with-clear-button.cpp
	widgets/modal-configuration-widget.cpp
	widgets/path-edit.cpp
	widgets/path-list-edit.cpp
	widgets/progress-icon.cpp
	widgets/progress-label.cpp
	widgets/protocols-combo-box.cpp
	widgets/proxy-combo-box.cpp
	widgets/preview.cpp
	widgets/roster-widget.cpp
	widgets/select-buddy-combo-box.cpp
	widgets/select-buddy-popup.cpp
	widgets/select-file.cpp
	widgets/select-font.cpp
	widgets/status-button.cpp
	widgets/status-buttons.cpp
	widgets/status-menu.cpp
	widgets/syntax-editor.cpp
	widgets/talkable-delegate.cpp
	widgets/talkable-delegate-configuration.cpp
	widgets/talkable-menu-item.cpp
	widgets/talkable-menu-manager.cpp
	widgets/talkable-painter.cpp
	widgets/talkable-tree-view.cpp
	widgets/toolbar.cpp
	widgets/tool-tip-class-manager.cpp

	widgets/configuration/buddy-list-background-colors-widget.cpp
	widgets/configuration/config-action-button.cpp
	widgets/configuration/config-check-box.cpp
	widgets/configuration/config-color-button.cpp
	widgets/configuration/config-combo-box.cpp
	widgets/configuration/config-gg-password-edit.cpp
	widgets/configuration/config-hot-key-edit.cpp
	widgets/configuration/config-label.cpp
	widgets/configuration/config-line-separator.cpp
	widgets/configuration/config-line-edit.cpp
	widgets/configuration/config-list-widget.cpp
	widgets/configuration/config-path-list-edit.cpp
	widgets/configuration/config-preview.cpp
	widgets/configuration/config-proxy-combo-box.cpp
	widgets/configuration/config-radio-button.cpp
	widgets/configuration/config-select-file.cpp
	widgets/configuration/config-select-font.cpp
	widgets/configuration/config-slider.cpp
	widgets/configuration/config-spin-box.cpp
	widgets/configuration/config-syntax-editor.cpp
	widgets/configuration/config-widget-value.cpp
	widgets/configuration/config-widget.cpp
	widgets/configuration/configuration-widget.cpp
	widgets/configuration/config-section.cpp
	widgets/configuration/config-group-box.cpp
	widgets/configuration/config-tab.cpp
	widgets/configuration/notifier-configuration-widget.cpp
	widgets/configuration/notify-group-box.cpp
	widgets/configuration/notify-tree-widget.cpp

	windows/about.cpp
	windows/add-buddy-window.cpp
	windows/add-conference-window.cpp
	windows/buddy-data-window.cpp
	windows/buddy-data-window-aware-object.cpp
	windows/buddy-delete-window.cpp
	windows/chat-data-window.cpp
	windows/chat-window.cpp
	windows/choose-description.cpp
	windows/configuration-window.cpp
	windows/file-transfer-window.cpp
	windows/group-properties-window.cpp
	windows/kadu-window.cpp
	windows/kadu-window-actions.cpp
	windows/main-configuration-window.cpp
	windows/main-window.cpp
	windows/merge-buddies-window.cpp
	windows/message-dialog.cpp
	windows/modules-window.cpp
	windows/multilogon-window.cpp
	windows/password-window.cpp
	windows/plugin-error-dialog.cpp
	windows/progress-window.cpp
	windows/progress-window2.cpp
	windows/proxy-action-context.cpp
	windows/proxy-edit-window.cpp
	windows/search-window.cpp
	windows/search-window-actions.cpp
	windows/subscription-window.cpp
	windows/syntax-editor-window.cpp
	windows/updates-dialog.cpp
	windows/window-notifier-window.cpp
	windows/your-accounts.cpp

	windows/open-chat-with/open-chat-with.cpp
	windows/open-chat-with/open-chat-with-contact-list-runner.cpp
	windows/open-chat-with/open-chat-with-runner-manager.cpp
)

set (gui_MOC_SRCS
	hot-key.h
	status-icon.h

	actions/chat/add-conference-action.h
	actions/chat/leave-chat-action.h

	actions/action.h
	actions/actions.h
	actions/action-context.h
	actions/action-description.h
	actions/base-action-context.h
	actions/change-status-action.h
	actions/delete-talkable-action.h
	actions/default-proxy-action.h
	actions/edit-talkable-action.h

	widgets/account-add-widget.h
	widgets/account-avatar-widget.h
	widgets/account-buddy-list-widget.h
	widgets/account-create-widget.h
	widgets/account-edit-widget.h
	widgets/accounts-combo-box.h
	widgets/actions-combo-box.h
	widgets/buddy-avatar-widget.h
	widgets/buddy-contacts-table-delegate.h
	widgets/buddy-contacts-table-item.h
	widgets/buddy-contacts-table-model.h
	widgets/buddy-contacts-table-model-proxy.h
	widgets/buddy-contacts-table.h
	widgets/buddy-general-configuration-widget.h
	widgets/buddy-groups-configuration-widget.h
	widgets/buddy-personal-info-configuration-widget.h
	widgets/buddy-options-configuration-widget.h
	widgets/buddy-info-panel.h
	widgets/chat-edit-box.h
	widgets/chat-edit-box-size-manager.h
	widgets/chat-messages-view.h
	widgets/chat-view-network-access-manager.h
	widgets/chat-widget.h
	widgets/chat-widget-actions.h
	widgets/chat-widget-manager.h
	widgets/choose-identity-widget.h
	widgets/color-button.h
	widgets/color-selector.h
	widgets/custom-input.h
	widgets/custom-input-menu-manager.h
	widgets/delayed-line-edit.h
	widgets/file-transfer-widget.h
	widgets/filter-widget.h
	widgets/filtered-tree-view.h
	widgets/group-list.h
	widgets/group-tab-bar.h
	widgets/groups-combo-box.h
	widgets/identities-combo-box.h
	widgets/kadu-tree-view.h
	widgets/kadu-tree-view-delegate.h
	widgets/kadu-web-view.h
	widgets/line-edit-clear-button.h
	widgets/line-edit-with-clear-button.h
	widgets/modal-configuration-widget.h
	widgets/path-edit.h
	widgets/path-list-edit.h
	widgets/preview.h
	widgets/proxy-combo-box.h
	widgets/progress-icon.h
	widgets/progress-label.h
	widgets/protocols-combo-box.h
	widgets/roster-widget.h
	widgets/select-buddy-combo-box.h
	widgets/select-buddy-popup.h
	widgets/select-file.h
	widgets/select-font.h
	widgets/status-button.h
	widgets/status-buttons.h
	widgets/status-menu.h
	widgets/syntax-editor.h
	widgets/talkable-delegate.h
	widgets/talkable-menu-manager.h
	widgets/talkable-tree-view.h
	widgets/toolbar.h

	widgets/configuration/buddy-list-background-colors-widget.h
	widgets/configuration/config-action-button.h
	widgets/configuration/config-check-box.h
	#widgets/configuration/config-widget-value.h
	widgets/configuration/configuration-widget.h
	widgets/configuration/config-label.h
	widgets/configuration/config-color-button.h
	widgets/configuration/config-combo-box.h
	widgets/configuration/config-gg-password-edit.h
	widgets/configuration/config-group-box.h
	widgets/configuration/config-hot-key-edit.h
	widgets/configuration/config-line-edit.h
	widgets/configuration/config-line-separator.h
	widgets/configuration/config-list-widget.h
	widgets/configuration/config-path-list-edit.h
	widgets/configuration/config-preview.h
	widgets/configuration/config-proxy-combo-box.h
	widgets/configuration/config-radio-button.h
	widgets/configuration/config-section.h
	widgets/configuration/config-select-file.h
	widgets/configuration/config-select-font.h
	widgets/configuration/config-slider.h
	widgets/configuration/config-spin-box.h
	widgets/configuration/config-syntax-editor.h
	widgets/configuration/config-tab.h
	widgets/configuration/kadu-scroll-area.h
	widgets/configuration/kadu-tab-widget.h
	widgets/configuration/notify-tree-widget.h
	widgets/configuration/notifier-configuration-widget.h
	widgets/configuration/notify-group-box.h

	windows/about.h
	windows/add-buddy-window.h
	windows/add-conference-window.h
	windows/buddy-data-window.h
	windows/buddy-delete-window.h
	windows/chat-data-window.h
	windows/chat-window.h
	windows/choose-description.h
	windows/configuration-window.h
	windows/file-transfer-window.h
	windows/group-properties-window.h
	windows/kadu-window.h
	windows/kadu-window-actions.h
	windows/main-configuration-window.h
	windows/main-window.h
	windows/merge-buddies-window.h
	windows/modules-window.h
	windows/multilogon-window.h
	windows/password-window.h
	windows/plugin-error-dialog.h
	windows/progress-window.h
	windows/progress-window2.h
	windows/proxy-action-context.h
	windows/proxy-edit-window.h
	windows/search-window.h
	windows/search-window-actions.h
	windows/subscription-window.h
	windows/syntax-editor-window.h
	windows/updates-dialog.h
	windows/window-notifier-window.h
	windows/your-accounts.h

	windows/open-chat-with/open-chat-with.h
	windows/open-chat-with/open-chat-with-runner-manager.h
)

if (MINGW)
	set_source_files_properties (windows/open-chat-with/open-chat-with.cpp PROPERTIES
		COMPILE_FLAGS "-fno-strict-aliasing"
	)
endif (MINGW)

kadu_subdirectory (gui "${gui_SRCS}" "${gui_MOC_SRCS}" "")

=== kadu-core/icons/CMakeLists.txt ===
set (icons_SRCS
	icons-manager.cpp
	kadu-icon.cpp
)

set (icons_MOC_SRCS
	icons-manager.h
	kadu-icon.h
)

kadu_subdirectory (icons "${icons_SRCS}" "${icons_MOC_SRCS}" "")

=== debian/changelog ===
kadu (0.11.2-1) unstable; urgency=low

  * New upstream release
  * Removed debian/patches/05-kadu_completion_fix.patch -- fix already
    included upstream
  * Added libqt4-svg to kadu's Depends

 -- Patryk Cisek <patryk@debian.org>  Tue, 17 Apr 2012 07:52:47 +0200

kadu (0.11.1-3) unstable; urgency=low

  * Backported the following fix of kadu_completion plugin from upstream
    repository:
    git://gitorious.org/mime_tex/kadu_completion.git
    The backported commit's fix: dfa94a16d3ff51e9bc05996836e4d46627d93d84

 -- Patryk Cisek <patryk@debian.org>  Wed, 04 Apr 2012 15:15:58 +0200

=== debian/control ===
Source: kadu
Section: net
Priority: optional
Maintainer: Patryk Cisek <patryk@debian.org>
Vcs-Git: git://git.debian.org/users/patryk/kadu.git
Vcs-Browser: http://git.debian.org/?p=users/patryk/kadu.git
Build-Depends: aspell,
               bzip2,
               cmake (>=2.6),
               debhelper (>= 7),
               libasound2-dev,
               libaspell-dev,
               libaudio-dev,
               libdbus-1-dev,
               libgadu-dev,
               libidn11-dev,
               libindicate-qt-dev,
               libmpdclient-dev,
               libphonon-dev,
               libqca2-dev,
               libqt4-dev,
               libqtwebkit-dev,
               libsndfile1-dev (>= 1.0),
               libsqlite3-dev,
               libxfixes-dev,
               libxss-dev,
               libxtst-dev,
               patchutils (>= 0.2.25),
               sharutils,
               x11proto-scrnsaver-dev,
               zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://kadu.net

Package: kadu
Architecture: any
Depends: kadu-common (= ${source:Version}),
         libqca2-plugin-ossl,
         libqt4-sql-sqlite,
         libqt4-svg,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: kadu-external-modules (>= 0.10.0-2)
Breaks: kadu-external-modules (<< 0.10.0-2)
Replaces: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides Kadu along with plugins developed by Kadu developers.

Package: kadu-common
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: kadu-external-modules (>= 0.10.0-2)
Breaks: kadu-external-modules (<< 0.10.0-2)
Replaces: kadu-external-modules (<< 0.10.0-2)
Suggests: kadu-themes
Description: Gadu-Gadu/XMPP client for X11
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides data common for all architectures.

Package: kadu-dev
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Development files needed to compile plugins for kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides development files needed to compile plugins for Kadu.

Package: kadu-external-modules
Architecture: any
Depends: kadu (>= 0.10.0-2), ${misc:Depends}, ${shlibs:Depends}
Breaks: kadu (<< 0.10.0-2), kadu-common (<< 0.10.0-2)
Replaces: kadu (<< 0.10.0-2), kadu-common (<< 0.10.0-2)
Description: Additional plugins for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional packages developed by external developers.
 See README.Debian for more details.

Package: kadu-themes
Architecture: all
Depends: ${misc:Depends}
Recommends: kadu
Description: Additional icons and emoticons for Kadu
 Gadu-Gadu is a Windows instant messenger, very popular in Poland.
 Kadu is a Qt4 client of Gadu-Gadu and XMPP for *nix systems.
 .
 This package provides additional icons, sounds and emoticons themes for
 Kadu.

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

PKG_DIR=$(shell pwd)
BUILD_DIR=$(CURDIR)/build-dir
INSTALL_DIR=$(PKG_DIR)/debian/tmp
DEB_BUILD_ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir $(BUILD_DIR)
	find . -name '*.o' -delete
	bash debian/handle_external.sh copy
	cd $(BUILD_DIR) && cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr $(PKG_DIR)
	touch configure-stamp

#Architecture
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	cd $(BUILD_DIR) && $(MAKE)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	touch $@

clean: 
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	test -d $(BUILD_DIR) && cd $(BUILD_DIR) && $(MAKE) clean || true
	rm -rf $(BUILD_DIR)
	bash debian/handle_external.sh remove
	dh_clean 

install: install-indep install-arch
install-indep:
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	# Remove all license files
	find $(INSTALL_DIR) -name '[lL][iI][cC][eE][nN][sS][eE].txt' -delete
	# Remove all thumbnails files
	find $(INSTALL_DIR) -name Thumbs.db -delete
	rm -f $(INSTALL_DIR)/usr/share/kadu/themes/sounds/bns/sound.conf~
	chmod 755 $(INSTALL_DIR)/usr/share/kadu/themes/icons/oxygen/src/rebuild-statuses.sh
	# Move FindKadu.cmake to proper directory
	mkdir -p $(INSTALL_DIR)/usr/share/cmake-2.8/Modules/
	cp $(INSTALL_DIR)/usr/share/cmake/Modules/FindKadu.cmake $(INSTALL_DIR)/usr/share/cmake-2.8/Modules/
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_prep -s 
	dh_installdirs -s
	cd $(BUILD_DIR) && $(MAKE) DESTDIR=$(INSTALL_DIR) install
	cp $(INSTALL_DIR)/usr/share/kadu/ChangeLog debian/kadu/usr/share/doc/kadu/about-changes-tab.txt
	rm -f $(INSTALL_DIR)/usr/share/kadu/modules/data/osd_hints/License
	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress -XAUTHORS -XTHANKS -XLICENSE -Xabout-changes-tab.txt
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep

.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure
